%% GLM for RGC data
function [xfinal] = GLM_RGC
load RGCsimdata.mat
% choose  time window length
stimulus = stim;
time_step = stim_dt;
stimuli_length = 15;
N = length(spiketimes);
M = length(stimulus)+ 1 - stimuli_length;

% make matrix of stimuli using stimulus data 
stimuli = zeros(M,stimuli_length);

for i = length(stimulus):-1:stimuli_length
    stimuli(i-stimuli_length+1,:) = (stimulus(i-stimuli_length+1:i));  
   
end

% make a vector of spike times
number_spikes = zeros(1,length(stimulus));
sp_time = round(spiketimes/time_step);
a = unique(sp_time);
out = [a,histc(sp_time(:),a)];
for i = 1: length(out)
   number_spikes(out(i,1)) = out(i,2); 
end
% number_spikes is a matrix of the length of stimulus, which shows how many
% spikes were at time starting from 0 with step time_step
number_spikes(1:stimuli_length-1) = 0;

% find STA
s_av = sum(stimuli,1)/M;

%find difference between stimuli and average stimuli
sta = zeros(M,stimuli_length);
for t = 1:M
    sta(t,:) = stimuli(t,:) - s_av;
end

% multiply the respective stimuli part by the number of spikes
sta_pre = zeros(length(number_spikes),stimuli_length);
for i = length(number_spikes):-1:stimuli_length
    sta_pre(i,:) = number_spikes(i)*sta(i-stimuli_length+1,:);
end
st = zeros(M,15);
for i =1:15
for t = 1:M
    st(t,i) = stimuli(t,i)*stimuli(t,i);
end
end
st_f = sum(st,1);
sta_ff = sum(sta_pre,1);
k = sta_ff./st_f;
figure; plot(k)
% initial guess
x0 = ones(1,stimuli_length+1);
xfinal = example(x0);
hold on;plot(xfinal(2:end)*1.67,'*')
title ('Comparison of STA and linear filter')
xlabel ('time step')
legend ('STA','Linear filter')
end
function [xfinal] = example(x)
options = optimoptions('fminunc','Algorithm','quasi-newton','TolFun',1e-8,'GradObj','on','DerivativeCheck','off','Diagnostics','on','Display','iter');
[xfinal,fval,exitflag,output,grad] = fminunc(@rwg,x,options);
end

function [LL,g] = rwg(x)
%%data
load RGCsimdata.mat
% choose time step and stimuli length
stimulus = stim;
time_step = stim_dt;
stimuli_length = 15;
M = length(stimulus)+ 1 - stimuli_length;

% make matrix of stimuli using stimulus data 
stimuli = zeros(M,stimuli_length);

for i = length(stimulus):-1:stimuli_length
    stimuli(i-stimuli_length+1,:) = (stimulus(i-stimuli_length+1:i));  
   
end

% make a vector of spike times
number_spikes = zeros(1,length(stimulus));
sp_time = round(spiketimes/time_step);
a = unique(sp_time);
out = [a,histc(sp_time(:),a)];
for i = 1: length(out)
   number_spikes(out(i,1)) = out(i,2); 
end
% number_spikes is a matrix of the length of stimulus, which shows how many
% spikes were at time starting from 0 with step time_step
number_spikes(1:stimuli_length-1) = 0;

%% gradient
LL1 = zeros(M,1);
LL2 = zeros(M,1);
for i = 1:M
    LL1(i) = number_spikes(1,i+stimuli_length-1)*(x(2:end)*stimuli(i,:)'+x(1));
    LL2(i) = exp(x(2:end)*stimuli(i,:)'+x(1));
end
LL = -sum(LL1) + sum(LL2);

if nargout > 1 % gradient required
LL11 = zeros(M,15);
LL12 = zeros(M,15);

LL22 = zeros(M,1);
for t = 1:15
for ii = 1:M
    LL11(ii,t) = number_spikes(1,ii+stimuli_length-1)*(stimuli(ii,t)) ;
    LL12(ii,t) = stimuli(ii,t)*exp(x(2:end)*stimuli(ii,:)'+x(1));
end
end
for it = 1:M
        LL22(it,1) = exp(x(2:end)*stimuli(it,:)'+x(1));

end
    g = [-sum(number_spikes)+sum(LL22),-sum(LL11,1)+sum(LL12,1)];
end

end

