function [xfinal] = GQM_1
load RGCsimdata.mat
% choose time step and stimuli length
r = 1;
stimulus = repelem(stim,r);
time_step = stim_dt/r;
stimuli_length = 15*r;
M = length(stimulus)+ 1 - stimuli_length;
% make stimuli preceeding moments of time
stimuli = zeros(stimuli_length,M);
for i = length(stimulus):-1:stimuli_length
    stimuli(:,i-stimuli_length+1) = stimulus(i-stimuli_length+1:i);  
   
end

% make a vector of spike times
number_spikes = zeros(1,length(stimulus));
sp_time = ceil(spiketimes/time_step);
a = unique(sp_time);
out = [a,histc(sp_time(:),a)];
for i = 1: length(out)
   number_spikes(out(i,1)) = out(i,2); 
end

%number of positive and negative filters
N = 1;
omega = 1;
% initial guess
x0 = [(ones(1,stimuli_length)-randn(1,stimuli_length))/5,(ones(1,stimuli_length)-randn(1,stimuli_length))/5,0.01];
xfinal = example(x0,number_spikes,stimuli,N,omega);
% combination check. one filter is optimal
% LL = zeros(3,3);
% for n = 1:3
% for p = 1:3    
% N = n+p;
% omega = [ones(1,p),ones(1,n)*(-1)];
% x0 = (ones(1,stimuli_length*(1+N))-randn(1,stimuli_length*(1+N))/10)*0.01;
% xfinal = example(x0,number_spikes,stimuli,N,omega);
% 
% L1 = zeros(M,1);
% L2 = zeros(M,1);
% 
% for i = 1:M
%     q = zeros(1,N);
%     for j = 1:N
%         q(j) = omega(j)*(xfinal(stimuli_length*j+1:stimuli_length*j+stimuli_length)*stimuli(:,i))^2;
%     end
%     Q = sum(q);
%     L1(i) = number_spikes(i+stimuli_length-1,1)*(xfinal(1:stimuli_length)*stimuli(:,i)+Q );
%     L2(i) = exp(xfinal(1:stimuli_length)*stimuli(:,i)+ Q );
% end
% LL(p,n) = -sum(L1) + sum(L2)
% 
% end
% 
% end
% g1 = zeros(M,1);
% for i = 1:M
%     g1(i) = xfinal(1:stimuli_length)*stimuli(:,i);
% end
% g2 = zeros(M,1);
% g3 = zeros (M,1);
% for i = 1:M
%     g2(i) = (xfinal(stimuli_length+1:2*stimuli_length)*stimuli(:,i))^2;
%     g3(i) = (xfinal(31:45)*stimuli(:,i))^2;
% end
% g = g2+g3;

%LL

figure; plot(xfinal(1:15));
hold on;plot(xfinal(16:30))
title ('Linear and quadratic filter for RGC')
xlabel ('time step')
legend ('linear filter','Quadratic filter')
end 

function xfinal = example(x,spikes,stimuli,N,omega)
options = optimoptions('fminunc','Algorithm','quasi-newton','TolFun',1e-8,'GradObj','on','Diagnostics','on','Display','iter');
fun  = @(x)rwg(x,spikes,stimuli,N,omega);
[xfinal,fval,exitflag,output,grad] = fminunc(fun,x,options);
end


function [LL,g] = rwg(x,spikes,stimuli,N,omega)
number_spikes = spikes';
stimuli_length = 15;
s = size(stimuli);
M = s(2);

%% gradient and loglikelihood
LL1 = zeros(M,1);
LL2 = zeros(M,1);

for i = 1:M
    q = zeros(1,N);
    for j = 1:N
        q(j) = omega(j)*(x(stimuli_length*j+1:stimuli_length*j+stimuli_length)*stimuli(:,i))^2;
    end
    Q = sum(q);
    LL1(i) = number_spikes(i+stimuli_length-1,1)*(x(1:stimuli_length)*stimuli(:,i)+Q + x(end));
    LL2(i) = exp(x(1:stimuli_length)*stimuli(:,i)+ Q + x(end));
end
LL = -sum(LL1) + sum(LL2);





if nargout > 1 % gradient required
LL11 = zeros(stimuli_length,M);
LL12 = zeros(stimuli_length,M);
LL21 = zeros(stimuli_length*N,M);
LL22 = zeros(stimuli_length*N,M);
LL33 = zeros (M,1);

for ii = 1:M
    q = zeros(1,N);
    for j = 1:N
        q(j) = omega(j)*(x(stimuli_length*j+1:stimuli_length*j+stimuli_length)*stimuli(:,ii))^2;
    end
    Q = sum(q);
    
    for t = 1:stimuli_length
    LL11(t,ii) = number_spikes(ii+stimuli_length-1,1)*(stimuli(t,ii)) ;
    LL12(t,ii) = stimuli(t,ii)*exp(x(1:stimuli_length)*stimuli(:,ii) + Q+ x(end));
    end
    for tt = 1:stimuli_length*N
              j = ceil(tt/stimuli_length);
                if tt>=1 && tt<=stimuli_length
                                    ttt = tt;
                                      LL21(tt,ii ) = 2*number_spikes(ii+stimuli_length-1,1)*omega(j)*stimuli(ttt,ii)*x(stimuli_length+1:2*stimuli_length)*stimuli(:,ii);
                                      LL22(tt,ii ) = 2*omega(j)*stimuli(ttt,ii)*x(stimuli_length+1:2*stimuli_length)*stimuli(:,ii)*exp(x(1:stimuli_length)*stimuli(:,ii) +Q);
                else
                                     ttt = tt-stimuli_length*(j-1);
                                      LL21(tt,ii ) = 2*number_spikes(ii+stimuli_length-1,1)*stimuli(ttt,ii)*omega(j)*x(stimuli_length*j+1:stimuli_length*j+stimuli_length)*stimuli(:,ii);
                                      LL22(tt,ii ) = 2*omega(j)*stimuli(ttt,ii)*x(stimuli_length*j+1:stimuli_length*j+stimuli_length)*stimuli(:,ii)*exp(x(1:stimuli_length)*stimuli(:,ii) +Q+ x(end));
                end
    end
    LL33(ii,1) = number_spikes(ii+stimuli_length-1,1) - exp(x(1:stimuli_length)*stimuli(:,ii) + Q+ x(end));

end

   g = [(-sum(LL11,2)+sum(LL12,2))',(-sum(LL21,2)+sum(LL22,2))',-sum(LL33)];


             
      
end



    




end
