% upload the real data and use LNP model with STC filter
load LGN_FFdata.mat

spiketimes = FFspks;
stimulus = FFstim;
time_step = DTstim;


%% give general names to variables

% use low resolution in this case and work with 120 sec stimulus
stimulus = repelem(stimulus,1);
time_step = time_step/1;

% set up N, M and assume stimuli length
stimuli_length = 15*1;
N = length(spiketimes);
M = length(stimulus)+ 1 - stimuli_length;

% find how many spikes were at a particular moment of time
n = zeros(1,length(stimulus));
sp_time = round(spiketimes/time_step);
a = unique(sp_time)';
out = [a,histc(sp_time(:),a)];
for i = 1: length(out)
   n(out(i,1)) = out(i,2); 
end
n(1:stimuli_length-1) = 0;
% make matrix of stimuli
stimuli = zeros(M,stimuli_length);

for i = 1: M-1
    stimuli(i,:) = stimulus(i:i+stimuli_length-1);
   
end

%% Find STA, which is used for finding STC
% find average stimuli
s_av = sum(stimuli,1)/M;
%find difference between stimuli and average stimuli
sta = zeros(M,stimuli_length);
for t = 1:M
    sta(t,:) = stimuli(t,:) - s_av;
end

% multiply the respective stimuli part by the number of spikes
sta_pre = zeros(length(n),stimuli_length);
for i = length(n):-1:stimuli_length
    sta_pre(i,:) = n(i)*sta(i-stimuli_length+1,:);
end
% %STA itself
sta_f = (1/N)*sum(sta_pre,1);

stimuli2 = zeros(M+stimuli_length-1,stimuli_length);
for i = M+stimuli_length-1:-1:stimuli_length
    stimuli2(i,:) = (stimulus(i-stimuli_length+1:i)); 
   
end


%% Find STC for 120 sec stimulus
stimuli2 = zeros(M+stimuli_length-1,stimuli_length);

for i = M+stimuli_length-1:-1:stimuli_length
    stimuli2(i,:) = (stimulus(i-stimuli_length+1:i));  % may be do fliplr
   
end
 % find the difference
tstc2 = 0;

for t = length(stimuli2):-1:stimuli_length
    tstc2 = tstc2 + n(t)*(stimuli2(t,:) - sta_f)'*(stimuli2(t,:) - sta_f)  ; 
end
tstc_f2 = (1/(N-1))*(tstc2);

% find untriggered
unstc2 = 0;
for t = length(stimuli2):-1:stimuli_length
    unstc2 = unstc2 +  (stimuli2(t,:)  )'*(stimuli2(t,:)  ) ; 
end
unstc_f2 = (1/(length(stimuli2)-stimuli_length-1))*(unstc2);

stc_f= tstc_f2 - unstc_f2; 


[V2,D2] = eig(stc_f);
figure; plot(diag(D2),'o')
title('Eigen values from which we get two filters')



%% generator signal
g_with_time = zeros(M+stimuli_length-1,2);
stimuli2 = zeros(M+stimuli_length-1,stimuli_length);
% two filters
stc_ff1 = V2(:,1);
stc_ff2 = V2(:,2);

for i = M+stimuli_length-1:-1:stimuli_length
    stimuli2(i,:) = (stimulus(i-stimuli_length+1:i)); 
   
end
% choose number of bins for the histogram
w = 10;
fn =figure;
for i = 1:M
   g = (stc_ff1)'*stimuli2(i,:)';
   g2 = (stc_ff2)'*stimuli2(i,:)';
   g_with_time(i,1) = g;
   g_with_time(i,2) = g2;
end
figure;
h = histogram2(g_with_time(:,1),g_with_time(:,2),w);
title ('histogram for generator signal, which was found for 120 sec stimulus')
xlabel ('generator signal values for the first filter')
ylabel ('generator signal values for the second filter ')
counts = h.Values;
bin_size = (abs(min(g_with_time(:,1)))+max(g_with_time(:,1)))/w;
bin_size2 = (abs(min(g_with_time(:,2)))+max(g_with_time(:,2)))/w;
intervals = min(g_with_time(:,1)):bin_size:max(g_with_time(:,1));
intervals2 = min(g_with_time(:,2)):bin_size2:max(g_with_time(:,2));
Spike_per_bin = zeros(length(intervals2),length(intervals));
for ii = 1:length(intervals2)-1
    aa = intervals2(1,ii);
    bb = intervals2(1,ii+1);
for i=1:length(intervals)-1
    a = intervals(1,i);
    b = intervals (1,i+1);
    k = 0;
    sp = 0;
    Ind_av = find(g_with_time(:,1)>=a & g_with_time(:,1)<b & g_with_time(:,2)>=aa & g_with_time(:,2)<bb);
    for j = 1:length(Ind_av)
        k = [k;find(out(:,1)==Ind_av(j))];
    end
    for j = 1:length(k)
        if k(j)~=0
            sp = sp + out(k(j),2);
        end
    end
    if length(Ind_av)>0
    Spike_per_bin(ii,i+1) = sp/length(Ind_av);
    end
end
end
figure;surf(Spike_per_bin)
title ('Non-linearity F for 120 sec stimulus ')
xlabel ('generator signal values for the first filter')
ylabel ('generator signal values for the second filter ')
zlabel ('spike rate (spike per bin)')

%% take new data - another stimulus : repeated stimulus and corresponding spike times
MM = length(FFstimR)+ 1 - stimuli_length;
g_with_time3 = zeros(MM+stimuli_length-1,2);
stimuli3 = zeros(MM+stimuli_length-1,stimuli_length);

for i = MM+stimuli_length-1:-1:stimuli_length
    stimuli3(i,:) = (FFstimR(i-stimuli_length+1:i));  % may be do fliplr
   
end
% choose number of bins for the histogram
w = 10;
% find generator signal using sta filter found for the other stimulus
for i = 1:MM
   g = (stc_ff1)'*stimuli3(i,:)';
   g2 = (stc_ff2)'*stimuli3(i,:)';
   g_with_time3(i,1) = g;
   g_with_time3(i,2) = g2;
end
% using found above non-linearity F find the spike rate
rate = 0;
for i =1:1200
    for jj= 1:length(intervals2)-1
    for j = 1:length(intervals)-1
        if g_with_time3(i,1)>=intervals(j) && g_with_time3(i,1)<intervals(j)+bin_size/2 && g_with_time3(i,2)>=intervals2(jj) && g_with_time3(i,2)<intervals2(jj)+bin_size2/2
        rate = [rate,Spike_per_bin(jj,j)];
        end
        if g_with_time3(i,1)>=intervals(j) && g_with_time3(i,1)<intervals(j)+bin_size/2 && g_with_time3(i,2)>=intervals2(jj)+bin_size2/2 && g_with_time3(i,2)<intervals2(jj+1)
        rate = [rate,Spike_per_bin(jj+1,j)];
        end
        if g_with_time3(i,1)>=intervals(j)+bin_size/2 && g_with_time3(i,1)<intervals(j+1) && g_with_time3(i,2)>=intervals2(jj) && g_with_time3(i,2)<intervals2(jj)+bin_size2/2
        rate = [rate,Spike_per_bin(jj,j+1)];
        end
        if g_with_time3(i,1)>=intervals(j)+bin_size/2 && g_with_time3(i,1)<intervals(j+1) && g_with_time3(i,2)>=intervals2(jj)+bin_size2/2 && g_with_time3(i,2)<intervals2(jj+1)
        rate = [rate,Spike_per_bin(jj+1,j+1)];
        end
        
    end
    end
end
%rate = rate(2:end);

ind = find(FFspksR== -1);
ind = [1,ind];
n2 = zeros(64,length(FFstimR));

for k = 1:length(ind)-1
sp_time2 = round(FFspksR(1*ind(k)+1:ind(k+1)-1)/time_step);
a2 = unique(sp_time2)';
out2 = [a2,histc(sp_time2(:),a2)];
for i = 1: length(out2)
   n2(k,out2(i,1)) = out2(i,2); 
end
n2(k,1:stimuli_length-1) = 0;
end
nn = sum(n2,1)/64;
% find the measured spike rate
newnn = 0;
newrate = 0;
for i = 1:10:length(nn)-1
    newnn = [newnn,sum(nn(i:i+1))];
    newrate = [newrate,sum(rate(i:i+1))];
end
figure;
plot(newnn)
hold on
plot(newrate,'r')
title ('Comparison of measured and estimated spike rates')
xlabel ('time step (one time step corresponds to 0.0083 sec)')
ylabel ('spike rate (spike per bin)')
legend ('measured','estimated')
% R_squared_rate = 1 - (mean squared error) / (variance of observed response)
var_obs = sum(newnn.^2)/121;
newrate(find(isnan(newrate))) = 0;
mean_sq_error = sum((newnn-newrate).^2)/121;
R_squared = 1 - mean_sq_error/var_obs

% newnn = newnn(2:end);
% newrate = newrate(2:end);
% figure;plot(time,newnn)
% hold on
% plot(time,newrate,'r')
% time = 0:time_step:1;

