% choose optimal number of filters
function [xfinal,Comp] = NIM_1
load RGCsimdata.mat
% choose time step and stimuli length
r = 8;
stimulus = repelem(stim,r);
t = round(length(stimulus)/2);
time_step = stim_dt/r;
stimuli_length = 10*r;

% define stimuli preceeding times
stimulus1 = stimulus(1:t);
M = length(stimulus1)+ 1 - stimuli_length;
stimuli = zeros(stimuli_length,M);
for i = length(stimulus1):-1:stimuli_length
    stimuli(:,i-stimuli_length+1) = stimulus(i-stimuli_length+1:i);  
   
end

% make a vector of spike times
number_spikes = zeros(1,length(stimulus));
% check ceil
sp_time = ceil(spiketimes/time_step);
a = unique(sp_time);
out = [a,histc(sp_time(:),a)];
for i = 1: length(out)
   number_spikes(out(i,1)) = out(i,2); 
end

number_spikes1= number_spikes(1:t);
num_spikes = number_spikes(t+1:end)';

M1= length(stimulus)-t + 1 - stimuli_length;
stimuli2 = zeros(stimuli_length,M1);
k = M1;
for i = length(stimulus):-1:t+stimuli_length
    stimuli2(:,k) = stimulus(i-stimuli_length+1:i); % 
    k = k-1;
end
%number of positive and negative filters
s =1;
for p = 1:3
ss = 1;
for n = 0:3
if n ==0 && p ==0
    ss = ss +1;       
    continue
else
N = n+p;
if n == 0
omega = ones(1,p);
x0 = [(ones(1,stimuli_length*p)-randn(1,stimuli_length*p))/5,0.1];

elseif p==0
    omega = -ones(1,n);
    x0 = [-ones(1,stimuli_length*n)*0.1,0.1];

else
    omega = [ones(1,p),-ones(1,n)];
    x0 = [(ones(1,stimuli_length*p)-randn(1,stimuli_length*p))/5,-ones(1,stimuli_length*n)*0.1,0.1];

end

xfinal = example(x0,number_spikes1,stimuli,N,omega);
end

LL1 = zeros(M1,1);
LL2 = zeros(M1,1);
for i = 1:M1
    q = zeros(1,N);
    for j = 1:N
        q(j) = omega(j)*log(1+exp(prod(xfinal,stimuli2(:,i),j)));
    end
    Q = sum(q);
    LL1(i) = num_spikes(i+stimuli_length-1,1)*log(log(1+exp(Q-xfinal(end))));
    LL2(i) = log(1+exp(Q - xfinal(end)));
end
LL = -sum(LL1) + sum(LL2);
Comp(s,ss) = LL;  
ss = ss +1;   
end
s = s+1;
end
% LL comparison for optimal filters
Comp
end 

function xfinal = example(x,spikes,stimuli,N,omega)
options = optimoptions('fminunc','Algorithm','quasi-newton','TolFun',1e-8,'GradObj','on','Diagnostics','on','Display','iter');
fun  = @(x)rwg(x,spikes,stimuli,N,omega);
[xfinal,fval,exitflag,output,grad] = fminunc(fun,x,options);
end


function [LL,g] = rwg(x,spikes,stimuli,N,omega)
number_spikes = spikes';
stimuli_length = 10*8;
s = size(stimuli);
M = s(2);

%% LL
LL1 = zeros(M,1);
LL2 = zeros(M,1);
lam = 1000;


for i = 1:M
    q = zeros(1,N);
    for j = 1:N
        q(j) = omega(j)*log(1+exp(prod(x,stimuli(:,i),j)));
    end
    Q = sum(q);
    LL1(i) = number_spikes(i+stimuli_length-1,1)*log(log(1+exp(Q-x(end))));
    LL2(i) = log(1+exp(Q - x(end)));
end

if N ==2 
LL3 = zeros(stimuli_length,1);
LL4 = zeros(stimuli_length,1);
for i = 1:stimuli_length-1
    LL3(i) = (x(1+i)-x(i))^2;
end
for i = stimuli_length+1:2*stimuli_length-1
    LL4(i-stimuli_length) = (x(1+i)-x(i))^2;
end
LL5 = [LL3;LL4];
LL = -sum(LL1) + sum(LL2) + lam*sum(LL5);
else
LL = -sum(LL1) + sum(LL2);
end
%%gradient
if nargout > 1 % gradient required
LL11 = zeros(stimuli_length*N,M);
LL22 = zeros(1,M);

for ii = 1:M
    q = zeros(1,N);
    for j = 1:N
       
        q(j) = omega(j)*log(1+exp(x(stimuli_length*(j-1)+1:stimuli_length*j)*stimuli(:,ii)));
    end
    Q = sum(q);
     
    for n = 1:N
         
     
    for t = stimuli_length*(n-1)+1:stimuli_length*n
    if t>=1 && t<=stimuli_length
    tt = t;
    LL11(t,ii) = (number_spikes(ii+stimuli_length-1,1)/(log(1+exp(Q-x(end))))-1)*omega(n)*(stimuli(tt,ii))*...
        exp(Q-x(end))*(1/(1+exp(Q-x(end))))*exp(x(stimuli_length*(n-1)+1:stimuli_length*n)*stimuli(:,ii))*...
        (1/(1+exp(x(stimuli_length*(n-1)+1:stimuli_length*n)*stimuli(:,ii))));
    else
    tt = t-stimuli_length*(n-1);
    LL11(t,ii) = (number_spikes(ii+stimuli_length-1,1)/(log(1+exp(Q-x(end))))-1)*omega(n)*(stimuli(tt,ii))*...
        exp(Q-x(end))*(1/(1+exp(Q-x(end))))*exp(x(stimuli_length*(n-1)+1:stimuli_length*n)*stimuli(:,ii))*...
        (1/(1+exp(x(stimuli_length*(n-1)+1:stimuli_length*n)*stimuli(:,ii))));
    end
    end
    
    
    end
    LL22(1,ii) = (number_spikes(ii+stimuli_length-1,1)/(log(1+exp(Q-x(end))))-1)*(-1)*...
        exp(Q-x(end))*(1/(1+exp(Q-x(end))));
    
end

if N ==2 
LL13 = zeros(stimuli_length,1);
for ttt = 2:stimuli_length-1
    LL13(ttt) = 2*lam*(x(ttt) - x(ttt-1)) - 2*lam*(x(1+ttt)-x(ttt));
end
LL13(1) = -2*lam*(x(2)-x(1));
LL13(end) = 2*lam*(x(stimuli_length)-x(stimuli_length-1));
LL14 = zeros(stimuli_length,1);
for ttt = stimuli_length+2:2*stimuli_length-1
    LL14(ttt-stimuli_length) = 2*lam*(x(ttt) - x(ttt-1)) - 2*lam*(x(1+ttt)-x(ttt));
end
LL14(1) = -2*lam*(x(stimuli_length+2)-x(stimuli_length+1));
LL14(end) = 2*lam*(x(2*stimuli_length)-x(stimuli_length*2-1));
LL55 = [LL13;LL14]';
g = [(-sum(LL11,2))'+LL55,(-sum(LL22,2))'];
else
g = [(-sum(LL11,2))',(-sum(LL22,2))'];
end
      
end
end
function a = prod (x,s,j)
dim = size(s);
a = x(dim*(j-1)+1:dim*j)*s;
end
